#include "../lib/rcsid.h"

RCS_ID("$Header: svn+ssh://kcase.org/Source/svn/kcase/tags/bb/2.6/bb/path.c 178 2004-05-05 06:09:03Z kc $")

/*
 * Copyright 1991 by Greg Titus. 
 *
 * Do with this as you will, but it'd be nice if you told me about any
 * uses you find for it, enhancements, etc.
 *
 */

#include "bb.h"
#include <errno.h>
extern int errno;

char *find_file(char *name)
{
    char buf[BUFFERSIZE];
    char *e, *b;
    FILE *f;

    if ((f = fopen(e = (char *)tilde(name), "r")) != NULL) {
	fclose(f);
	return e;
    }
    if (errno != ENOENT || *name == '/' || *name == '~')
	return NULL;
    e = Path;
    b = buf;
    while (1) {
	if (*e == ';' || *e == '\0') {
	    *b++ = '/';
	    strcpy(b, name);
	    if ((f = fopen(b = (char *)tilde(buf), "r")) != NULL) {
		fclose(f);
		return b;
	    }
	    b = buf;
	    if (!*e)
		return NULL;
	    e++;
	} else
	    *b++ = *e++;
    }
}
