#include "../lib/rcsid.h"

RCS_ID("$Header: svn+ssh://kcase.org/Source/svn/kcase/tags/bb/2.6/server/kill.c 178 2004-05-05 06:09:03Z kc $")

#include "server.h"

void server_kill(int i)
{
  int slot;

  read_socket_int(Client[i].socket, &slot);
  if(slot < 0 || slot >= MAX_CLIENTS)
    SERVER_ERROR("slot number out of range");
  if(!Client[slot].signed_on)
    SERVER_ERROR("no user signed on in that slot");
  if(Client[i].uid != Client[slot].uid && !OPERATOR(Client[i].uid))
    SERVER_ERROR("permission denied");
  close_client(slot);
  if(i != slot) write_socket_code(Client[i].socket, SERVER_ACK);
}
